<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-pragma">{-# LANGUAGE OverloadedStrings #-}</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Hyperion.Bootstrap.Qdelaunay</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-4"></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Monad</span></span><span>                     </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">forM_</span></span><span class="hs-special">)</span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Attoparsec.ByteString.Char8</span></span><span>  </span><span class="hs-keyword">hiding</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">IResult</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.ByteString.Char8</span></span><span>             </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">BS</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Double.Conversion.ByteString</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">toExponential</span></span><span class="hs-special">)</span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Vector</span></span><span>                       </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Vector</span></span><span class="hs-special">)</span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Vector</span></span><span>                       </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">V</span></span><span>
</span><span id="line-11"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">GHC.IO.Handle</span></span><span>                     </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">hClose</span></span><span class="hs-special">)</span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Hyperion.Log</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Log</span></span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">System.Process</span></span><span>                    </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">CreateProcess</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-14"></span><span>                                                    </span><span class="annot"><span class="hs-identifier">StdStream</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-15"></span><span>                                                    </span><span class="annot"><span class="hs-identifier">withCreateProcess</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">proc</span></span><span class="hs-special">)</span><span>
</span><span id="line-16"></span><span>
</span><span id="line-17"></span><span class="annot"><a href="Hyperion.Bootstrap.Qdelaunay.html#qdelaunay"><span class="hs-identifier hs-type">qdelaunay</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">FilePath</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Vector</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Vector</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">Vector</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span class="hs-special">]</span><span>
</span><span id="line-18"></span><span id="qdelaunay"><span class="annot"><span class="annottext">qdelaunay :: FilePath -&gt; Vector (Vector Double) -&gt; IO [Vector Int]
</span><a href="Hyperion.Bootstrap.Qdelaunay.html#qdelaunay"><span class="hs-identifier hs-var hs-var">qdelaunay</span></a></span></span><span> </span><span id="local-6989586621679451010"><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679451010"><span class="hs-identifier hs-var">executable</span></a></span></span><span> </span><span id="local-6989586621679451009"><span class="annot"><span class="annottext">Vector (Vector Double)
</span><a href="#local-6989586621679451009"><span class="hs-identifier hs-var">points</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-19"></span><span>  </span><span class="annot"><span class="annottext">CreateProcess
-&gt; (Maybe Handle
    -&gt; Maybe Handle
    -&gt; Maybe Handle
    -&gt; ProcessHandle
    -&gt; IO [Vector Int])
-&gt; IO [Vector Int]
forall a.
CreateProcess
-&gt; (Maybe Handle
    -&gt; Maybe Handle -&gt; Maybe Handle -&gt; ProcessHandle -&gt; IO a)
-&gt; IO a
</span><span class="hs-identifier hs-var">withCreateProcess</span></span><span> </span><span class="annot"><span class="annottext">CreateProcess
</span><a href="#local-6989586621679451008"><span class="hs-identifier hs-var">qProc</span></a></span><span> </span><span class="annot"><span class="annottext">((Maybe Handle
  -&gt; Maybe Handle
  -&gt; Maybe Handle
  -&gt; ProcessHandle
  -&gt; IO [Vector Int])
 -&gt; IO [Vector Int])
-&gt; (Maybe Handle
    -&gt; Maybe Handle
    -&gt; Maybe Handle
    -&gt; ProcessHandle
    -&gt; IO [Vector Int])
-&gt; IO [Vector Int]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679451007"><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679451007"><span class="hs-identifier hs-var">stdin</span></a></span></span><span> </span><span id="local-6989586621679451006"><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679451006"><span class="hs-identifier hs-var">stdout</span></a></span></span><span> </span><span class="annot"><span class="annottext">Maybe Handle
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">ProcessHandle
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-20"></span><span>    </span><span class="hs-keyword">case</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679451007"><span class="hs-identifier hs-var">stdin</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679451006"><span class="hs-identifier hs-var">stdout</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-21"></span><span>      </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span id="local-6989586621679451005"><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679451005"><span class="hs-identifier hs-var">hin</span></a></span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span id="local-6989586621679451004"><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679451004"><span class="hs-identifier hs-var">hout</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-22"></span><span>        </span><span class="annot"><span class="annottext">Handle -&gt; IO ()
</span><a href="#local-6989586621679451003"><span class="hs-identifier hs-var">writeInput</span></a></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679451005"><span class="hs-identifier hs-var">hin</span></a></span><span>
</span><span id="line-23"></span><span>        </span><span class="annot"><span class="annottext">Handle -&gt; IO ()
</span><span class="hs-identifier hs-var">hClose</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679451005"><span class="hs-identifier hs-var">hin</span></a></span><span>
</span><span id="line-24"></span><span>        </span><span id="local-6989586621679451002"><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679451002"><span class="hs-identifier hs-var">out</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Handle -&gt; IO ByteString
</span><span class="hs-identifier hs-var">BS.hGetContents</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679451004"><span class="hs-identifier hs-var">hout</span></a></span><span>
</span><span id="line-25"></span><span>        </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Parser [Vector Int] -&gt; ByteString -&gt; Either FilePath [Vector Int]
forall a. Parser a -&gt; ByteString -&gt; Either FilePath a
</span><span class="hs-identifier hs-var">parseOnly</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int -&gt; Parser [Vector Int]
</span><a href="Hyperion.Bootstrap.Qdelaunay.html#qdelaunayOutput"><span class="hs-identifier hs-var">qdelaunayOutput</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450998"><span class="hs-identifier hs-var">dim</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679451002"><span class="hs-identifier hs-var">out</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-26"></span><span>          </span><span class="annot"><span class="hs-identifier hs-type">Right</span></span><span> </span><span id="local-6989586621679450997"><span class="annot"><span class="annottext">[Vector Int]
</span><a href="#local-6989586621679450997"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">[Vector Int] -&gt; IO [Vector Int]
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">[Vector Int]
</span><a href="#local-6989586621679450997"><span class="hs-identifier hs-var">r</span></a></span><span>
</span><span id="line-27"></span><span>          </span><span class="annot"><span class="hs-identifier hs-type">Left</span></span><span> </span><span id="local-6989586621679450996"><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679450996"><span class="hs-identifier hs-var">e</span></a></span></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">FilePath -&gt; IO [Vector Int]
forall (m :: * -&gt; *) a. MonadIO m =&gt; FilePath -&gt; m a
</span><span class="hs-identifier hs-var">Log.throwError</span></span><span> </span><span class="annot"><span class="annottext">(FilePath -&gt; IO [Vector Int]) -&gt; FilePath -&gt; IO [Vector Int]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">FilePath
</span><span class="hs-string">&quot;Could not parse qdelaunay output: &quot;</span></span><span> </span><span class="annot"><span class="annottext">FilePath -&gt; FilePath -&gt; FilePath
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679450996"><span class="hs-identifier hs-var">e</span></a></span><span>
</span><span id="line-28"></span><span>      </span><span class="annot"><span class="annottext">(Maybe Handle, Maybe Handle)
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">FilePath -&gt; IO [Vector Int]
forall (m :: * -&gt; *) a. MonadIO m =&gt; FilePath -&gt; m a
</span><span class="hs-identifier hs-var">Log.throwError</span></span><span> </span><span class="annot"><span class="annottext">FilePath
</span><span class="hs-string">&quot;Couldn't create pipe to qdelaunay process&quot;</span></span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-30"></span><span>    </span><span id="local-6989586621679451008"><span class="annot"><span class="annottext">qProc :: CreateProcess
</span><a href="#local-6989586621679451008"><span class="hs-identifier hs-var hs-var">qProc</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">FilePath -&gt; [FilePath] -&gt; CreateProcess
</span><span class="hs-identifier hs-var">proc</span></span><span> </span><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679451010"><span class="hs-identifier hs-var">executable</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">FilePath
</span><span class="hs-string">&quot;Qt&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">FilePath
</span><span class="hs-string">&quot;i&quot;</span></span><span class="hs-special">]</span><span class="hs-special">)</span><span>
</span><span id="line-31"></span><span>      </span><span class="hs-special">{</span><span> </span><span class="annot"><span class="annottext">std_in :: StdStream
</span><a href="#local-6989586621679450994"><span class="hs-identifier hs-var">std_in</span></a></span><span>  </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">StdStream
</span><span class="hs-identifier hs-var">CreatePipe</span></span><span>
</span><span id="line-32"></span><span>      </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">std_out :: StdStream
</span><a href="#local-6989586621679450992"><span class="hs-identifier hs-var">std_out</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">StdStream
</span><span class="hs-identifier hs-var">CreatePipe</span></span><span>
</span><span id="line-33"></span><span>      </span><span class="hs-special">}</span><span>
</span><span id="line-34"></span><span>    </span><span id="local-6989586621679451003"><span class="annot"><span class="annottext">writeInput :: Handle -&gt; IO ()
</span><a href="#local-6989586621679451003"><span class="hs-identifier hs-var hs-var">writeInput</span></a></span></span><span> </span><span id="local-6989586621679450991"><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679450991"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-35"></span><span>      </span><span class="annot"><span class="annottext">Handle -&gt; ByteString -&gt; IO ()
</span><span class="hs-identifier hs-var">BS.hPutStrLn</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679450991"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">FilePath -&gt; ByteString
</span><span class="hs-identifier hs-var">BS.pack</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int -&gt; FilePath
forall a. Show a =&gt; a -&gt; FilePath
</span><span class="hs-identifier hs-var">show</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450998"><span class="hs-identifier hs-var">dim</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span>      </span><span class="annot"><span class="annottext">Handle -&gt; ByteString -&gt; IO ()
</span><span class="hs-identifier hs-var">BS.hPutStrLn</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679450991"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">FilePath -&gt; ByteString
</span><span class="hs-identifier hs-var">BS.pack</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int -&gt; FilePath
forall a. Show a =&gt; a -&gt; FilePath
</span><span class="hs-identifier hs-var">show</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450987"><span class="hs-identifier hs-var">numPoints</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-37"></span><span>      </span><span class="annot"><span class="annottext">Vector (Vector Double) -&gt; (Vector Double -&gt; IO ()) -&gt; IO ()
forall (t :: * -&gt; *) (m :: * -&gt; *) a b.
(Foldable t, Monad m) =&gt;
t a -&gt; (a -&gt; m b) -&gt; m ()
</span><span class="hs-identifier hs-var">forM_</span></span><span> </span><span class="annot"><span class="annottext">Vector (Vector Double)
</span><a href="#local-6989586621679451009"><span class="hs-identifier hs-var">points</span></a></span><span> </span><span class="annot"><span class="annottext">((Vector Double -&gt; IO ()) -&gt; IO ())
-&gt; (Vector Double -&gt; IO ()) -&gt; IO ()
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679450986"><span class="annot"><span class="annottext">Vector Double
</span><a href="#local-6989586621679450986"><span class="hs-identifier hs-var">v</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-38"></span><span>        </span><span class="annot"><span class="annottext">Handle -&gt; ByteString -&gt; IO ()
</span><span class="hs-identifier hs-var">BS.hPutStrLn</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679450991"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">ByteString -&gt; [ByteString] -&gt; ByteString
</span><span class="hs-identifier hs-var">BS.intercalate</span></span><span> </span><span class="annot"><span class="annottext">ByteString
</span><span class="hs-string">&quot; &quot;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector ByteString -&gt; [ByteString]
forall a. Vector a -&gt; [a]
</span><span class="hs-identifier hs-var">V.toList</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(Double -&gt; ByteString) -&gt; Vector Double -&gt; Vector ByteString
forall a b. (a -&gt; b) -&gt; Vector a -&gt; Vector b
</span><span class="hs-identifier hs-var">V.map</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int -&gt; Double -&gt; ByteString
</span><span class="hs-identifier hs-var">toExponential</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">16</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Vector Double
</span><a href="#local-6989586621679450986"><span class="hs-identifier hs-var">v</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-39"></span><span>    </span><span id="local-6989586621679450987"><span class="annot"><span class="annottext">numPoints :: Int
</span><a href="#local-6989586621679450987"><span class="hs-identifier hs-var hs-var">numPoints</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Vector (Vector Double) -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="annot"><span class="annottext">Vector (Vector Double)
</span><a href="#local-6989586621679451009"><span class="hs-identifier hs-var">points</span></a></span><span>
</span><span id="line-40"></span><span>    </span><span id="local-6989586621679450998"><span class="annot"><span class="annottext">dim :: Int
</span><a href="#local-6989586621679450998"><span class="hs-identifier hs-var hs-var">dim</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Vector Double -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector (Vector Double)
</span><a href="#local-6989586621679451009"><span class="hs-identifier hs-var">points</span></a></span><span> </span><span class="annot"><span class="annottext">Vector (Vector Double) -&gt; Int -&gt; Vector Double
forall a. Vector a -&gt; Int -&gt; a
</span><span class="hs-operator hs-var">V.!</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">0</span></span><span class="hs-special">)</span><span>
</span><span id="line-41"></span><span>
</span><span id="line-42"></span><span class="annot"><a href="Hyperion.Bootstrap.Qdelaunay.html#qdelaunayOutput"><span class="hs-identifier hs-type">qdelaunayOutput</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Parser</span></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">Vector</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span class="hs-special">]</span><span>
</span><span id="line-43"></span><span id="qdelaunayOutput"><span class="annot"><span class="annottext">qdelaunayOutput :: Int -&gt; Parser [Vector Int]
</span><a href="Hyperion.Bootstrap.Qdelaunay.html#qdelaunayOutput"><span class="hs-identifier hs-var hs-var">qdelaunayOutput</span></a></span></span><span> </span><span id="local-6989586621679450980"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450980"><span class="hs-identifier hs-var">dim</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-44"></span><span>  </span><span id="local-6989586621679450979"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450979"><span class="hs-identifier hs-var">numSimplices</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Parser Int
forall a. Integral a =&gt; Parser a
</span><span class="hs-identifier hs-var">decimal</span></span><span> </span><span class="annot"><span class="annottext">Parser Int -&gt; Parser ByteString () -&gt; Parser Int
forall (f :: * -&gt; *) a b. Applicative f =&gt; f a -&gt; f b -&gt; f a
</span><span class="hs-operator hs-var">&lt;*</span></span><span> </span><span class="annot"><span class="annottext">Parser ByteString ()
</span><span class="hs-identifier hs-var">endOfLine</span></span><span>
</span><span id="line-45"></span><span>  </span><span class="annot"><span class="annottext">Int -&gt; Parser ByteString (Vector Int) -&gt; Parser [Vector Int]
forall (m :: * -&gt; *) a. Monad m =&gt; Int -&gt; m a -&gt; m [a]
</span><span class="hs-identifier hs-var">count</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450979"><span class="hs-identifier hs-var">numSimplices</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Parser ByteString (Vector Int)
</span><a href="#local-6989586621679450974"><span class="hs-identifier hs-var">simplex</span></a></span><span> </span><span class="annot"><span class="annottext">Parser ByteString (Vector Int)
-&gt; Parser ByteString () -&gt; Parser ByteString (Vector Int)
forall (f :: * -&gt; *) a b. Applicative f =&gt; f a -&gt; f b -&gt; f a
</span><span class="hs-operator hs-var">&lt;*</span></span><span> </span><span class="annot"><span class="annottext">Parser ByteString ()
</span><span class="hs-identifier hs-var">endOfLine</span></span><span class="hs-special">)</span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-47"></span><span>    </span><span id="local-6989586621679450974"><span class="annot"><span class="annottext">simplex :: Parser ByteString (Vector Int)
</span><a href="#local-6989586621679450974"><span class="hs-identifier hs-var hs-var">simplex</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Int -&gt; Parser Int -&gt; Parser ByteString (Vector Int)
forall (m :: * -&gt; *) a. Monad m =&gt; Int -&gt; m a -&gt; m (Vector a)
</span><span class="hs-identifier hs-var">V.replicateM</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679450980"><span class="hs-identifier hs-var">dim</span></a></span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">+</span></span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">1</span></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Parser Int
forall a. Integral a =&gt; Parser a
</span><span class="hs-identifier hs-var">decimal</span></span><span> </span><span class="annot"><span class="annottext">Parser Int -&gt; Parser ByteString ByteString -&gt; Parser Int
forall (f :: * -&gt; *) a b. Applicative f =&gt; f a -&gt; f b -&gt; f a
</span><span class="hs-operator hs-var">&lt;*</span></span><span> </span><span class="annot"><span class="annottext">Parser ByteString ByteString
</span><span class="hs-string">&quot; &quot;</span></span><span class="hs-special">)</span><span>
</span><span id="line-48"></span></pre></body></html>